Index: /trunk/Cocoa/Pester/Source/Pester.pbproj/nicholas.pbxuser
===================================================================
--- /trunk/Cocoa/Pester/Source/Pester.pbproj/nicholas.pbxuser	(revision 117)
+++ /trunk/Cocoa/Pester/Source/Pester.pbproj/nicholas.pbxuser	(revision 118)
@@ -4148,5 +6314,5 @@
 		name = "English: 3";
 		rLen = 0;
-		rLoc = 289;
+		rLoc = 341;
 		rType = 0;
 		vrLen = 360;
@@ -4276,14 +6442,4 @@
 		refType = 0;
 	};
-	E1669BB70412965E00050002 = {
-		fRef = E130B9AD03B7C59700000028;
-		isa = PBXTextBookmark;
-		name = "PSPowerManager.m: 13";
-		rLen = 0;
-		rLoc = 269;
-		rType = 0;
-		vrLen = 1364;
-		vrLoc = 0;
-	};
 	E1669BBD0412965E00050002 = {
 		fRef = F59E47A8036AAA6D016B311C;
@@ -4311,5 +6467,5 @@
 		name = "PSPowerManager.m: 13";
 		rLen = 0;
-		rLoc = 269;
+		rLoc = 288;
 		rType = 0;
 		vrLen = 1364;
@@ -4535,14 +6691,4 @@
 		vrLen = 1211;
 		vrLoc = 1834;
-	};
-	E16A0E6604005B0E00050002 = {
-		fRef = E17F2F4103FDF67700050002;
-		isa = PBXTextBookmark;
-		name = "OACalendarView.m: 545";
-		rLen = 0;
-		rLoc = 21556;
-		rType = 0;
-		vrLen = 1710;
-		vrLoc = 20144;
 	};
 	E16A0E6704005B0E00050002 = {
@@ -5437,5 +7583,5 @@
 		name = "PSPowerManager.m: 237";
 		rLen = 0;
-		rLoc = 8150;
+		rLoc = 12054;
 		rType = 0;
 		vrLen = 1226;
@@ -7163,14 +9309,4 @@
 		refType = 0;
 	};
-	E19DCC8703BE900300B934BF = {
-		fRef = 29B97316FDCFA39411CA2CEA;
-		isa = PBXTextBookmark;
-		name = "main.m: __VERSION__";
-		rLen = 0;
-		rLoc = 0;
-		rType = 0;
-		vrLen = 252;
-		vrLoc = 0;
-	};
 	E19DCC8903BE900300B934BF = {
 		fRef = E19DCCE403BE900300B934BF;
@@ -7192,14 +9328,4 @@
 		vrLen = 1095;
 		vrLoc = 0;
-	};
-	E19DCC8E03BE900300B934BF = {
-		fRef = E19DCCE503BE900300B934BF;
-		isa = PBXTextBookmark;
-		name = "NSValue.h: 88";
-		rLen = 46;
-		rLoc = 2491;
-		rType = 0;
-		vrLen = 1443;
-		vrLoc = 1143;
 	};
 	E19DCC9203BE900300B934BF = {
@@ -7649,10 +9775,4 @@
 		refType = 0;
 	};
-	E19DCCE503BE900300B934BF = {
-		isa = PBXFileReference;
-		name = NSValue.h;
-		path = /System/Library/Frameworks/Foundation.framework/Versions/C/Headers/NSValue.h;
-		refType = 0;
-	};
 	E19DCCE803BE900300B934BF = {
 		isa = PBXFileReference;
@@ -8058,14 +10178,4 @@
 		vrLoc = 668;
 	};
-	E1AFB0DB03C9A59C001509F3 = {
-		fRef = E19FD39F03C98645001509F3;
-		isa = PBXTextBookmark;
-		name = "PSWakeAlert.m: 24";
-		rLen = 0;
-		rLoc = 444;
-		rType = 0;
-		vrLen = 815;
-		vrLoc = 0;
-	};
 	E1AFB0E003C9A59C001509F3 = {
 		isa = PBXTargetBookmark;
@@ -8421,5 +10531,5 @@
 		name = "PSWakeAlert.m: 24";
 		rLen = 0;
-		rLoc = 444;
+		rLoc = 471;
 		rType = 0;
 		vrLen = 815;
@@ -8441,5 +10551,5 @@
 		name = "PSTimer.m: ";
 		rLen = 0;
-		rLoc = 6753;
+		rLoc = 6775;
 		rType = 0;
 		vrLen = 1086;
@@ -8451,5 +10561,5 @@
 		name = "PSPowerManager.m: 222";
 		rLen = 0;
-		rLoc = 7430;
+		rLoc = 11334;
 		rType = 0;
 		vrLen = 1665;
@@ -8471,5 +10581,5 @@
 		name = "PSPowerManager.m: 245";
 		rLen = 0;
-		rLoc = 7723;
+		rLoc = 11627;
 		rType = 0;
 		vrLen = 1673;
@@ -8481,5 +10591,5 @@
 		name = "PSWakeAlert.m: 24";
 		rLen = 0;
-		rLoc = 444;
+		rLoc = 471;
 		rType = 0;
 		vrLen = 815;
@@ -8501,5 +10611,5 @@
 		name = "PSPowerManager.h: 29";
 		rLen = 68;
-		rLoc = 527;
+		rLoc = 682;
 		rType = 0;
 		vrLen = 718;
@@ -8592,14 +10702,4 @@
 		vrLoc = 3394;
 	};
-	E1B46F5C04053C4F00050002 = {
-		fRef = F59DD4500358ABF4017318D0;
-		isa = PBXTextBookmark;
-		name = "English: 3";
-		rLen = 0;
-		rLoc = 289;
-		rType = 0;
-		vrLen = 360;
-		vrLoc = 0;
-	};
 	E1B46F5D04053C4F00050002 = {
 		fRef = E1B46FD904053C5000050002;
@@ -8611,14 +10711,4 @@
 		vrLen = 1558;
 		vrLoc = 1755;
-	};
-	E1B46F5E04053C4F00050002 = {
-		fRef = E1B46FDA04053C5000050002;
-		isa = PBXTextBookmark;
-		name = "NSDictionary.h: 50";
-		rLen = 22;
-		rLoc = 1813;
-		rType = 0;
-		vrLen = 1562;
-		vrLoc = 738;
 	};
 	E1B46F6004053C4F00050002 = {
@@ -9672,10 +11762,4 @@
 		name = NSFont.h;
 		path = /System/Library/Frameworks/AppKit.framework/Versions/C/Headers/NSFont.h;
-		refType = 0;
-	};
-	E1B46FDA04053C5000050002 = {
-		isa = PBXFileReference;
-		name = NSDictionary.h;
-		path = /System/Library/Frameworks/Foundation.framework/Versions/C/Headers/NSDictionary.h;
 		refType = 0;
 	};
@@ -10820,5 +12904,5 @@
 		name = "PSPowerManager.m: 35";
 		rLen = 0;
-		rLoc = 1215;
+		rLoc = 1418;
 		rType = 0;
 		vrLen = 1549;
@@ -10830,5 +12914,5 @@
 		name = "PSPowerManager.m: 34";
 		rLen = 0;
-		rLoc = 1185;
+		rLoc = 1388;
 		rType = 0;
 		vrLen = 1548;
@@ -10840,5 +12924,5 @@
 		name = "PSPowerManager.m: 270";
 		rLen = 0;
-		rLoc = 9118;
+		rLoc = 13021;
 		rType = 0;
 		vrLen = 1300;
@@ -10890,5 +12974,5 @@
 		name = "PSPowerManager.m: notificationPort";
 		rLen = 0;
-		rLoc = 7723;
+		rLoc = 11627;
 		rType = 0;
 		vrLen = 1717;
@@ -10960,8 +13044,4 @@
 		path = /System/Library/Frameworks/Foundation.framework/Versions/C/Headers/NSMethodSignature.h;
 		refType = 0;
-	};
-	E1C6405F03CF0A7A00050002 = {
-		isa = PBXTargetBookmark;
-		trg = 29B97326FDCFA39411CA2CEA;
 	};
 	E1C6406303CF0A7A00050002 = {
@@ -11068,14 +13148,4 @@
 		refType = 0;
 	};
-	E1C6414503C9AC4B001509F3 = {
-		fRef = E130B9AC03B7C59700000028;
-		isa = PBXTextBookmark;
-		name = "PSPowerManager.h: 33";
-		rLen = 0;
-		rLoc = 728;
-		rType = 0;
-		vrLen = 728;
-		vrLoc = 0;
-	};
 	E1C6414703C9AC4B001509F3 = {
 		fRef = E1BF6E9103C928D200050002;
@@ -11093,7 +13163,7 @@
 		name = "PSPowerManager.h: 29";
 		rLen = 136;
-		rLoc = 527;
-		rType = 0;
-		vrLen = 730;
+		rLoc = 682;
+		rType = 0;
+		vrLen = 728;
 		vrLoc = 0;
 	};
@@ -11102,6 +13172,6 @@
 		isa = PBXTextBookmark;
 		name = "PSPowerManager.m: 195";
-		rLen = 36;
-		rLoc = 6749;
+		rLen = 69;
+		rLoc = 10487;
 		rType = 0;
 		vrLen = 1382;
@@ -11113,7 +13183,7 @@
 		name = "PSPowerManager.h: 29";
 		rLen = 136;
-		rLoc = 527;
-		rType = 0;
-		vrLen = 730;
+		rLoc = 682;
+		rType = 0;
+		vrLen = 728;
 		vrLoc = 0;
 	};
@@ -11123,5 +13193,5 @@
 		name = "PSPowerManager.m: 229";
 		rLen = 0;
-		rLoc = 7684;
+		rLoc = 11588;
 		rType = 0;
 		vrLen = 1629;
@@ -11173,5 +13243,5 @@
 		name = "PSTimer.m: 224";
 		rLen = 0;
-		rLoc = 6459;
+		rLoc = 6481;
 		rType = 0;
 		vrLen = 1092;
@@ -11183,5 +13253,5 @@
 		name = "PSPowerManager.m: 223";
 		rLen = 27;
-		rLoc = 7546;
+		rLoc = 11450;
 		rType = 0;
 		vrLen = 1529;
@@ -11193,5 +13263,5 @@
 		name = "PSPowerManager.h: 29";
 		rLen = 0;
-		rLoc = 562;
+		rLoc = 717;
 		rType = 0;
 		vrLen = 728;
@@ -11203,5 +13273,5 @@
 		name = "PSPowerManager.m: 225";
 		rLen = 0;
-		rLoc = 7652;
+		rLoc = 11556;
 		rType = 0;
 		vrLen = 1591;
@@ -12183,4 +14253,110 @@
 		refType = 0;
 	};
+	E1DC3E39041F2CF600050002 = {
+		fRef = E1DC3E48041F2CF600050002;
+		isa = PBXTextBookmark;
+		name = "NSFileManager.h: 32";
+		rLen = 7;
+		rLoc = 1066;
+		rType = 0;
+		vrLen = 1827;
+		vrLoc = 2935;
+	};
+	E1DC3E3B041F2CF600050002 = {
+		fRef = E1DC3E47041F2CF600050002;
+		isa = PBXTextBookmark;
+		name = "unistd.h: 112";
+		rLen = 28;
+		rLoc = 4659;
+		rType = 0;
+		vrLen = 1343;
+		vrLoc = 3928;
+	};
+	E1DC3E3E041F2CF600050002 = {
+		isa = PBXTargetBookmark;
+		trg = 29B97326FDCFA39411CA2CEA;
+	};
+	E1DC3E3F041F2CF600050002 = {
+		fRef = E130B9AD03B7C59700000028;
+		isa = PBXTextBookmark;
+		name = "PSPowerManager.m: setWakeInterval:";
+		rLen = 0;
+		rLoc = 10486;
+		rType = 0;
+		vrLen = 1499;
+		vrLoc = 5994;
+	};
+	E1DC3E40041F2CF600050002 = {
+		fRef = E1DC3E31041F27DA00050002;
+		isa = PBXTextBookmark;
+		name = "wakein.h: 10";
+		rLen = 0;
+		rLoc = 225;
+		rType = 0;
+		vrLen = 169;
+		vrLoc = 0;
+	};
+	E1DC3E41041F2CF600050002 = {
+		fRef = E14A56ED041DD82F00050002;
+		isa = PBXTextBookmark;
+		name = "wakein.m: __VERSION__";
+		rLen = 0;
+		rLoc = 0;
+		rType = 0;
+		vrLen = 784;
+		vrLoc = 0;
+	};
+	E1DC3E42041F2CF600050002 = {
+		fRef = E1DC3E31041F27DA00050002;
+		isa = PBXTextBookmark;
+		name = "wakein.h: 11";
+		rLen = 0;
+		rLoc = 225;
+		rType = 0;
+		vrLen = 241;
+		vrLoc = 0;
+	};
+	E1DC3E43041F2CF600050002 = {
+		fRef = E14A56ED041DD82F00050002;
+		isa = PBXTextBookmark;
+		name = "wakein.m: __OBJC__";
+		rLen = 0;
+		rLoc = 168;
+		rType = 0;
+		vrLen = 890;
+		vrLoc = 0;
+	};
+	E1DC3E44041F2CF600050002 = {
+		fRef = E1DC3E31041F27DA00050002;
+		isa = PBXTextBookmark;
+		name = "wakein.h: 12";
+		rLen = 0;
+		rLoc = 225;
+		rType = 0;
+		vrLen = 241;
+		vrLoc = 0;
+	};
+	E1DC3E45041F2CF600050002 = {
+		fRef = E14A56ED041DD82F00050002;
+		isa = PBXTextBookmark;
+		name = "wakein.m: __OBJC__";
+		rLen = 0;
+		rLoc = 168;
+		rType = 0;
+		vrLen = 833;
+		vrLoc = 0;
+	};
+	E1DC3E47041F2CF600050002 = {
+		isa = PBXFileReference;
+		name = unistd.h;
+		path = /usr/include/unistd.h;
+		refType = 0;
+	};
+	E1DC3E48041F2CF600050002 = {
+		isa = PBXFileReference;
+		name = NSFileManager.h;
+		path = /System/Library/Frameworks/Foundation.framework/Versions/C/Headers/NSFileManager.h;
+		refType = 0;
+	};
 	E1DEF0FD03FE9F7C00050002 = {
 		fRef = E1DEF0FA03FE9F2C00050002;
@@ -12258,14 +14434,4 @@
 		vrLoc = 22427;
 	};
-	E1DEF13404003A5F00050002 = {
-		fRef = E1DEF32004003A6000050002;
-		isa = PBXTextBookmark;
-		name = "NSCalendarDate.h: 27";
-		rLen = 0;
-		rLoc = 928;
-		rType = 0;
-		vrLen = 1405;
-		vrLoc = 622;
-	};
 	E1DEF13704003A5F00050002 = {
 		fRef = E17F2F4303FDF67700050002;
@@ -12408,24 +14574,4 @@
 		vrLoc = 1492;
 	};
-	E1DEF15404003A5F00050002 = {
-		fRef = E1DEF31D04003A6000050002;
-		isa = PBXTextBookmark;
-		name = "NSDate.h: 22";
-		rLen = 40;
-		rLoc = 408;
-		rType = 0;
-		vrLen = 846;
-		vrLoc = 0;
-	};
-	E1DEF15B04003A5F00050002 = {
-		fRef = E1BF6E9003C928D200050002;
-		isa = PBXTextBookmark;
-		name = "PSTimer.h: 30";
-		rLen = 0;
-		rLoc = 987;
-		rType = 0;
-		vrLen = 1140;
-		vrLoc = 17;
-	};
 	E1DEF15D04003A5F00050002 = {
 		fRef = E1DEF30D04003A6000050002;
@@ -14024,5 +16170,5 @@
 		name = "English: 2";
 		rLen = 0;
-		rLoc = 325;
+		rLoc = 377;
 		rType = 0;
 		vrLen = 356;
@@ -16342,10 +18488,4 @@
 		refType = 0;
 	};
-	E1DEF31D04003A6000050002 = {
-		isa = PBXFileReference;
-		name = NSDate.h;
-		path = /System/Library/Frameworks/Foundation.framework/Versions/C/Headers/NSDate.h;
-		refType = 0;
-	};
 	E1DEF31E04003A6000050002 = {
 		isa = PBXFileReference;
@@ -16358,10 +18498,4 @@
 		name = CFString.h;
 		path = /System/Library/Frameworks/CoreFoundation.framework/Versions/A/Headers/CFString.h;
-		refType = 0;
-	};
-	E1DEF32004003A6000050002 = {
-		isa = PBXFileReference;
-		name = NSCalendarDate.h;
-		path = /System/Library/Frameworks/Foundation.framework/Versions/C/Headers/NSCalendarDate.h;
 		refType = 0;
 	};
@@ -16621,14 +18755,4 @@
 		refType = 0;
 	};
-	E1F7C61A041C5B0000FEF34D = {
-		fRef = E1F7C647041C5B0000FEF34D;
-		isa = PBXTextBookmark;
-		name = "NSBundle.h: 35";
-		rLen = 0;
-		rLoc = 892;
-		rType = 0;
-		vrLen = 1214;
-		vrLoc = 508;
-	};
 	E1F7C61B041C5B0000FEF34D = {
 		fRef = F5B79836035F64F80136A8DD;
@@ -16678,5 +18802,5 @@
 		rLoc = 3103;
 		rType = 0;
-		vrLen = 1479;
+		vrLen = 1416;
 		vrLoc = 1922;
 	};
@@ -16690,14 +18814,4 @@
 		vrLen = 1408;
 		vrLoc = 155;
-	};
-	E1F7C621041C5B0000FEF34D = {
-		fRef = F589C9C6035AA12B0155F4B2;
-		isa = PBXTextBookmark;
-		name = "Read Me.rtfd: 13";
-		rLen = 0;
-		rLoc = 542;
-		rType = 0;
-		vrLen = 2334;
-		vrLoc = 6515;
 	};
 	E1F7C622041C5B0000FEF34D = {
@@ -16738,14 +18852,4 @@
 		vrLoc = 1127;
 	};
-	E1F7C626041C5B0000FEF34D = {
-		fRef = E1BF6E9103C928D200050002;
-		isa = PBXTextBookmark;
-		name = "PSTimer.m: __GNUC__";
-		rLen = 0;
-		rLoc = 0;
-		rType = 0;
-		vrLen = 1502;
-		vrLoc = 1154;
-	};
 	E1F7C627041C5B0000FEF34D = {
 		fRef = F59F6CB50354E7DA01AEEDB1;
@@ -16845,5 +18949,5 @@
 		rLoc = 3103;
 		rType = 0;
-		vrLen = 1479;
+		vrLen = 1416;
 		vrLoc = 1922;
 	};
@@ -17047,10 +19151,4 @@
 		vrLen = 1053;
 		vrLoc = 1518;
-	};
-	E1F7C647041C5B0000FEF34D = {
-		isa = PBXFileReference;
-		name = NSBundle.h;
-		path = /System/Library/Frameworks/Foundation.framework/Versions/C/Headers/NSBundle.h;
-		refType = 0;
 	};
 	E1F7C648041C5B0000FEF34D = {
@@ -17072,5 +19170,15 @@
 		refType = 0;
 	};
-	E1F7C655041C623100FEF34D = {
+	E1F7C656041C623100FEF34D = {
+		fRef = 089C165DFE840E0CC02AAC07;
+		isa = PBXTextBookmark;
+		name = "English: 7";
+		rLen = 0;
+		rLoc = 229;
+		rType = 0;
+		vrLen = 229;
+		vrLoc = 0;
+	};
+	E1F7C658041C623100FEF34D = {
 		fRef = F560E2F10357506401A4E466;
 		isa = PBXTextBookmark;
@@ -17082,5 +19190,5 @@
 		vrLoc = 7442;
 	};
-	E1F7C656041C623100FEF34D = {
+	E1F7C659041C623100FEF34D = {
 		fRef = 089C165DFE840E0CC02AAC07;
 		isa = PBXTextBookmark;
@@ -17092,5 +19200,5 @@
 		vrLoc = 0;
 	};
-	E1F7C657041C623100FEF34D = {
+	E1F7C65A041C623100FEF34D = {
 		fRef = E10E71F4040C335800050002;
 		isa = PBXTextBookmark;
@@ -17101,44 +19209,4 @@
 		vrLen = 1654;
 		vrLoc = 4107;
-	};
-	E1F7C658041C623100FEF34D = {
-		fRef = F560E2F10357506401A4E466;
-		isa = PBXTextBookmark;
-		name = "PSApplication.m: 196";
-		rLen = 0;
-		rLoc = 8250;
-		rType = 0;
-		vrLen = 1793;
-		vrLoc = 7442;
-	};
-	E1F7C659041C623100FEF34D = {
-		fRef = 089C165DFE840E0CC02AAC07;
-		isa = PBXTextBookmark;
-		name = "English: 7";
-		rLen = 0;
-		rLoc = 229;
-		rType = 0;
-		vrLen = 229;
-		vrLoc = 0;
-	};
-	E1F7C65A041C623100FEF34D = {
-		fRef = E10E71F4040C335800050002;
-		isa = PBXTextBookmark;
-		name = "English: 95";
-		rLen = 0;
-		rLoc = 4713;
-		rType = 0;
-		vrLen = 1654;
-		vrLoc = 4107;
-	};
-	E1F7C65B041C623100FEF34D = {
-		fRef = E17F2F4103FDF67700050002;
-		isa = PBXTextBookmark;
-		name = "OACalendarView.m: 839";
-		rLen = 0;
-		rLoc = 34848;
-		rType = 0;
-		vrLen = 1399;
-		vrLoc = 34497;
 	};
 	E1FCECFD03C972CF001509F3 = {
Index: /trunk/Cocoa/Pester/Source/wakein.h
===================================================================
--- /trunk/Cocoa/Pester/Source/wakein.h	(revision 117)
+++ /trunk/Cocoa/Pester/Source/wakein.h	(revision 118)
@@ -7,7 +7,4 @@
 //
 
-enum {
-    PSWakeErrorSyntax = 1,
-    PSWakeErrorException = 2,
-    PSWakeErrorPermissions = 3
-};
+#define kPesterWakeTime @"WakeTime"
+#define kPesterWakeException @"WakeException"
Index: /trunk/Cocoa/Pester/Source/wakein.m
===================================================================
--- /trunk/Cocoa/Pester/Source/wakein.m	(revision 117)
+++ /trunk/Cocoa/Pester/Source/wakein.m	(revision 118)
@@ -8,38 +8,68 @@
 
 #import <Cocoa/Cocoa.h>
+#import "PSPowerManager.h"
 #import "wakein.h"
-#import "unistd.h"
-#import "PSPowerManager.h"
 
-void usage() {
-    fprintf(stderr, "usage: wakein secs\n");
-    exit(PSWakeErrorSyntax);
+// System interfaces
+#include <stdio.h>
+#include <unistd.h>
+// MoreIsBetter interfaces
+#include "MoreUNIX.h"
+#include "MoreSecurity.h"
+#include "MoreCFQ.h"
+
+static OSStatus SetAutoWake(AuthorizationRef auth, CFDictionaryRef request, CFDictionaryRef *result) {
+    OSStatus 	err;
+    assert(auth != NULL);
+    assert(request != NULL);
+    assert( result != NULL);
+    assert(*result == NULL);
+    assert(geteuid() == getuid());
+    static const char *kRightName = "net.sabi.Pester.wakein.SetAutoWake";
+    static const AuthorizationFlags kAuthFlags = kAuthorizationFlagDefaults | kAuthorizationFlagInteractionAllowed | kAuthorizationFlagExtendRights;
+    AuthorizationItem   right  = { kRightName, 0, NULL, 0 };
+    AuthorizationRights rights = { 1, &right };
+    err = AuthorizationCopyRights(auth, &rights, kAuthorizationEmptyEnvironment, kAuthFlags, NULL);
+    // sometimes we don't get here via authexec, so ignore this
+    
+    err = MoreSecSetPrivilegedEUID();
+    if (err != noErr) return err;
+    
+    [[NSAutoreleasePool alloc] init];
+
+    NSNumber *wakeTime = [(NSDictionary *)request objectForKey: kPesterWakeTime];
+    NSLog(@"setting wake time: %@", wakeTime);
+    if (wakeTime == nil) return noErr;
+
+    long long secs = [wakeTime unsignedLongLongValue];
+    if (secs < 0 || secs > ULONG_MAX) return paramErr;
+
+    NS_DURING
+        [PSPowerManager setWakeInterval: (unsigned long)secs];
+    NS_HANDLER
+        *result = (CFDictionaryRef)[NSDictionary dictionaryWithObject: [localException description] forKey: kPesterWakeException];
+        return ioErr;
+    NS_ENDHANDLER
+
+    *result = (CFDictionaryRef)[NSDictionary dictionary];
+
+    return noErr;
 }
 
-int main(int argc, const char *argv[])
-{
-    [[NSAutoreleasePool alloc] init];
+int main(int argc, const char *argv[]) {
+    OSStatus err;
+    int result;
+    AuthorizationRef auth;
 
-    if (argc != 2) usage();
+    auth = MoreSecHelperToolCopyAuthRef();
+    err = MoreSecDestroyInheritedEnvironment(kMoreSecKeepStandardFilesMask, argv);
+    if (err == 0) {
+        err = MoreUNIXIgnoreSIGPIPE();
+    }
+    if (err == 0) {
+        err = MoreSecHelperToolMain(STDIN_FILENO, STDOUT_FILENO, auth, SetAutoWake, argc, argv);
+    }
+    result = MoreSecErrorToHelperToolResult(err);
 
-    long long secs;
-    if (![[NSScanner scannerWithString: [NSString stringWithUTF8String: argv[1]]] scanLongLong: &secs])
-        usage();
-
-    if (secs < 0 || secs > ULONG_MAX)
-        usage();
-
-    if (geteuid() != 0) {
-        fprintf(stderr, "wakein: must be root\n");
-        return PSWakeErrorPermissions;
-    }
-
-    NS_DURING
-        [PSPowerManager setWakeInterval: secs];
-    NS_HANDLER
-        fprintf(stderr, "%s\n", [[localException description] UTF8String]);
-        return PSWakeErrorException;
-    NS_ENDHANDLER
-
-    return 0;
+    return result;
 }
